Boost Graph Library: Gürsoy-Atun Layout

# `gursoy_atun_layout`

### Synopsis

    // Non-named parameter version
    template<typename VertexListAndIncidenceGraph,  typename Topology,
    	 typename PositionMap, typename VertexIndexMap,
             typename EdgeWeightMap>
    void
    gursoy_atun_layout(const VertexListAndIncidenceGraph& g,
                       const Topology& space,
    		   PositionMap position,
    		   int nsteps = num_vertices(g),
    		   double diameter_initial = sqrt((double)num_vertices(g)),
    		   double diameter_final = 1,
    		   double learning_constant_initial = 0.8,
    		   double learning_constant_final = 0.2,
    		   VertexIndexMap vertex_index_map = get(vertex_index, g),
                       EdgeWeightMap weight = dummy_property_map());

    // Named parameter version
    template<typename VertexListAndIncidenceGraph, typename Topology,
             typename PositionMap, typename P, typename T, typename R>
    void
    gursoy_atun_layout(const VertexListAndIncidenceGraph& g,
                       const Topology& space,
                       PositionMap position,
                       const bgl_named_params<P,T,R>& params = all defaults);

### Description

This algorithm [60] performs layout of directed graphs, either weighted or unweighted. This algorithm is very different from the Kamada-Kawai and Fruchterman-Reingold algorithms, because it does not explicitly strive to layout graphs in a visually pleasing manner. Instead, it attempts to distribute the vertices uniformly within a topology (e.g., rectangle, sphere, heart shape), keeping vertices close to their neighbors; various topologies are provided by BGL, and users can also create their own. The algorithm itself is based on Self-Organizing Maps.

### Where Defined

`boost/graph/gursoy_atun_layout.hpp`

### Parameters

IN: `const Graph& g`

> The graph object on which the algorithm will be applied. The type `Graph` must be a model of Vertex List Graph and Incidence Graph.

IN: `const Topology& space`

> The topology on which the graph will be laid out. The type must model the Topology concept.

OUT: `PositionMap position`

> The property map that stores the position of each vertex. The type `PositionMap` must be a model of Lvalue Property Map such that the vertex descriptor type of `Graph` is convertible to its key type. Its value type must be `Topology::point_type`.

IN: `int nsteps`

> The number of iterations to perform.
> Default: `num_vertices(g)`

IN: `double diameter_initial`

> When a vertex is selected to be updated, all vertices that are reachable from that vertex within a certain diameter (in graph terms) will also be updated. This diameter begins at `diameter_initial` in the first iteration and ends at `diameter_final` in the last iteration, progressing exponentially. Generally the diameter decreases, in a manner similar to the cooling schedule in Fruchterman-Reingold. The diameter should typically decrease in later iterations, so this value should not be less than `diameter_final`.
> Default: `sqrt((double)num_vertices(g))`

IN: `double diameter_final`

> The final value of the diameter.
> Default: 1.0

IN: `double learning_constant_initial`

> The learning rate affects how far vertices can moved to rearrange themselves in a given iteration. The learning rate progresses linearly from the initial value to the final value, both of which should be between 0 and 1. The learning rate should typically decrease, so the initial value should not exceed the final value.
> Default: 0.8

IN: `double learning_constant_final`

> The final learning rate constant.
> Default: 0.2

IN: `VertexIndexMap vertex_index_map`

> This maps each vertex to an integer in the range `[0, num_vertices(g))`. The type `VertexIndexMap` must be a model of Readable Property Map. The value type of the map must be an integer type. The vertex descriptor type of the graph needs to be usable as the key type of the map.
> Default: `get(vertex_index, g)` Note: if you use this default, make sure your graph has an internal `vertex_index` property. For example, `adjacenty_list` with `VertexList=listS` does not have an internal `vertex_index` property.

IN: `EdgeWeightMap weight`

> This maps each edge to an weight. num_vertices(g)). This is only necessary when no displacement map is provided. The type `EdgeWeightMap` must be a model of Readable Property Map. The value type of the map must be an floating-point type compatible with `double`. The edge descriptor type of the graph needs to be usable as the key type of the map. When this map is a `dummy_property_map`, the algorithm assumes the graph is unweighted.
> Default: `dummy_property_map()`

### Named Parameters

IN: `iterations(int n)`

> Executes the algorithm for n iterations.
> Default: `num_vertices(g)`

IN: `diameter_range(std::pair range)`

> Range specifying the parameters (`diameter_initial`, `diameter_final`).
> Default: `std::make_pair(sqrt((double)num_vertices(g)), 1.0)`

IN: `learning_constant_range(std::pair range)`

> Range specifying the parameters (`learning_constant_initial`, `learning_constant_final`).
> Default: `std::make_pair(0.8, 0.2)`

IN: `edge_weight(EdgeWeightMap weight)`

> Equivalent to the non-named `weight` parameter.
> Default: `dummy_property_map()`

IN: `vertex_index_map(VertexIndexMap i_map)`

> Equivalent to the non-named `vertex_index_map` parameter.
> Default: `get(vertex_index, g)` Note: if you use this default, make sure your graph has an internal `vertex_index` property. For example, `adjacenty_list` with `VertexList=listS` does not have an internal `vertex_index` property.

Copyright © 2004 Trustees of Indiana University | Jeremiah Willcock, Indiana University ( ) Doug Gregor, Indiana University ( ) Andrew Lumsdaine, Indiana University ( )